<?php
/*
 * $Id: fmt-flash.php 711 2008-01-22 02:04:16Z Fritz Elfert $
 *
 * AllVideos Reloaded for Joomla! 1.5
 *
 * Author: Fritz Elfert
 * Copyright 2007 by Fritz Elfert
 *
 * Inspired by and partially based on:
 *
 *   The "AllVideos" Plugin for Joomla 1.0.x - Version 2.4
 *   Authors: Fotis Evangelou - George Chouliaras
 *   Copyright (c) 2006 JoomlaWorks.gr - http://www.joomlaworks.gr
 */

defined('_JEXEC') or die('Direct Access Is Not Allowed');

/**
 * Pattern definitions for Flash based builtin player
 */

$_p = "<script type=\"text/javascript\">\n".
    "swfobject.embedSWF('@RLOC@mediaplayer.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.115',@XPINST@,\n".
    "{file:'@MURL@',".
    "width:'@WIDTH@',".
    "height:'@HEIGHT@',".
    "@IF(ENABLEJS)@javascriptid:'p_@DIVID@',\n@/IF@".
    "@IF(PLTHUMBS)@thumbsinplaylist:'@PLTHUMBS@',\n@/IF@".
    "@IF(AUTOSCROLL)@autoscroll:'@AUTOSCROLL@',\n@/IF@".
    "@IFS(TYPE)@type:'@TYPE@',\n@/IFS@".
    "@IFS(CFG)@config:'@CFG@',\n@/IFS@".
    "@IFS(LINK)@link:'@LINK@',\n@/IFS@".
    "@IFS(LINK)@linkfromdisplay:'@LINKFROMDISPLAY@',\n@/IFS@".
    "@IFS(LINK)@linktarget:'@LINKTARGET@',\n@/IFS@".
    "@IFS(REPEAT)@repeat:'@REPEAT@',\n@/IFS@".
    "@IFS(SHUFFLE)@shuffle:'@SHUFFLE@',\n@/IFS@".
    "@IFS(RECURL)@recommendations:'@RECURL@',\n@/IFS@".
    "@IFS(DISPLAYWIDTH)@displaywidth:'@DISPLAYWIDTH@',\n@/IFS@".
    "@IFS(DISPLAYHEIGHT)@displayheight:'@DISPLAYHEIGHT@',\n@/IFS@".
    "@IFS(LOGO)@logo:'@LOGO@',\n@/IFS@".
    "enablejs:'@ENABLEJS@',".
    "autostart:'@AUTOSTART@',".
    "showicons:'@SHOWICONS@',".
    "showstop:'@SHOWSTOP@',".
    "showdigits:'@SHOWDIGITS@',\n".
    "showdownload:'@SHOWDOWNLOAD@',".
    "showvolume:'@SHOWVOLUME@',".
    "usefullscreen:'@USEFULLSCREEN@',".
    "backcolor:'@PBGCOLOR@',".
    "frontcolor:'@PFGCOLOR@',\n".
    "lightcolor:'@PHICOLOR@',".
    "screencolor:'@PSCCOLOR@',".
    "overstretch:'@STRETCH@'}\n,{".
    "allowscriptaccess:'always',".
    "seamlesstabbing:'true',".
    "allowfullscreen:'true',".
    "wmode:'@WMODE@',".
    "bgcolor:'@BGCOLOR@'},\n{".
    "id:'p_@DIVID@',".
    "styleclass:'@AVCSS@'});\n".
    "</script>";

$formats = array (
    'flv' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@VLOC@@CODE@.flv',
        ),
    ),

    'flvremote' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@CODE@',
        ),
    ),

    'auto' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@VLOC@@CODE@',
        ),
    ),

    'autoremote' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@CODE@',
        ),
    ),

    'swf' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@VLOC@@CODE@.swf',
        ),
    ),

    'swfremote' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@CODE@',
        ),
    ),

    'mp3' => array (
        'player' => &$_p,
        'avp' => array (
            '@WIDTH@' => '@AWIDTH@',
            '@HEIGHT@' => '@AHEIGHT@',
            '@MURL@' => '@ALOC@@CODE@.mp3',
        ),
    ),

    'mp3remote' => array (
        'player' => &$_p,
        'avp' => array (
            '@WIDTH@' => '@AWIDTH@',
            '@HEIGHT@' => '@AHEIGHT@',
            '@MURL@' => '@CODE@',
        ),
    ),

    'mp4-flv' => array (
        'player' => &$_p,
        'avp' => array (
            '@WIDTH@' => '@WIDTH@',
            '@HEIGHT@' => '@HEIGHT@',
            '@TYPE@' => 'flv',
            '@MURL@' => '@VLOC@@CODE@.mp4',
        ),
    ),

    'mp4-flvremote' => array (
        'player' => &$_p,
        'avp' => array (
            '@WIDTH@' => '@WIDTH@',
            '@HEIGHT@' => '@HEIGHT@',
            '@TYPE@' => 'flv',
            '@MURL@' => '@CODE@',
        ),
    ),

    'm4v' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@VLOC@@CODE@.m4v',
        ),
    ),

    'm4vremote' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@CODE@',
        ),
    ),

    '3gp' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@VLOC@@CODE@.3gp',
        ),
    ),

    '3gpremote' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@CODE@',
        ),
    ),

    'rbs' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@VLOC@@CODE@.rbs',
        ),
    ),

    'rbsremote' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@CODE@',
        ),
    ),

    'dropshots' => array (
        'ripper' => array(
            'url' => 'http://www.dropshots.com/V1.0/Media.getList?appid=dropshots&username=@USER@&min_taken_date=@CODE@&passwordprotection=false&output=xml',
            'urldecode' => 0,
            'regex' => '#<video>(.+)</video>#',
        ),
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@CODE@',
        ),
    ),
	
    'pls' => array (
        'player' => &$_p,
        'avp' => array (
            '@MURL@' => '@VLOC@@CODE@',
        ),
    ),
);
