<?php
/*
 * $Id: tags.php 681 2008-01-16 00:37:43Z Fritz Elfert $
 *
 * AllVideos Reloaded for Joomla! 1.5
 *
 * Author: Fritz Elfert
 * Copyright 2007 by Fritz Elfert
 *
 * Inspired by and partially based on:
 *
 *   The "AllVideos" Plugin for Joomla 1.0.x - Version 2.4
 *   Authors: Fotis Evangelou - George Chouliaras
 *   Copyright (c) 2006 JoomlaWorks.gr - http://www.joomlaworks.gr
 */

defined('_JEXEC') or die('Direct Access Is Not Allowed');
 
// list of supported tags. Each tag pointts to an associated
// format definition file, which defines the actual properties
// of that format. The format definitions are located in
// /plugins/content/avreloaded and are named 'fmt-<name>.php'
//
$tags = array (
    // builtin flash player
    'flv' => 'flash',
    'flvremote' => 'flash',
    'swf' => 'flash',
    'swfremote' => 'flash',
    'mp3' => 'flash',
    'mp3remote' => 'flash',
    'mp4-flv' => 'flash',
    'mp4-flvremote' => 'flash',
    // 'm4v' => 'flash',
    // 'm4vremote' => 'flash',
    '3gp' => 'flash',
    '3gpremote' => 'flash',
    'rbs' => 'flash',
    'rbsremote' => 'flash',
    'auto' => 'flash',
    'autoremote' => 'flash',

    // Windows Media
    'wmv' => 'wmp',
    'wmvremote' => 'wmp',
    'wma' => 'wmp',
    'wmaremote' => 'wmp',
    'avi' => 'wmp',
    'aviremote' => 'wmp',
    'bofunk' => 'wmp',
    'mpg' => 'wmp',
    'mpgremote' => 'wmp',
    'mpeg' => 'wmp',
    'mpegremote' => 'wmp',

    // QuickTime
    'mov' => 'qt',
    'movremote' => 'qt',
    'mp4' => 'qt',
    'mp4remote' => 'qt',

    // RealMedia
    'rm' => 'rm',
    'rmremote' => 'rm',
    'ram' => 'rm',
    'ramremote' => 'rm',

    // DivX
    'divx' => 'divx',
    'divxremote' => 'divx',

    // special presets, flash based
    'dropshots' => 'flash',
    'google' => 'google',
    'google.co.uk' => 'google',
    'google.com.au' => 'google',
    'google.de' => 'google',
    'google.es' => 'google',
    'google.fr' => 'google',
    'google.it' => 'google',
    'google.nl' => 'google',
    'google.pl' => 'google',
    'yahoo' => 'external',
    'ifilm' => 'external',
    'youtube' => 'external',
    'vimeo' => 'external',
    'metacafe' => 'external',
    // provider doesn't exist anymore 'boltaudio' => 'external',
    // provider doesn't exist anymore 'boltvideo' => 'external',
    'jumpcut' => 'external',
    'currenttv' => 'external',
    'freevideoblog' => 'external',
    'streetfire' => 'external',
    // provider doesnt exist anymore 'crossroad' => 'external',
    'stickam' => 'external',
    'myvideo' => 'external',
    'sevenload' => 'external',
    // doesn't work 'krazyshow' => 'external',
    'revver' => 'external',
    'clipfish' => 'external',
    'collegehumor' => 'external',
    'gametrailers' => 'external',
    'uume' => 'external',
    'tudou' => 'external',
    'seehaha' => 'external',
    'quxiu' => 'external',
    'wangyou' => 'external',
    'mofile' => 'external',
    'biku' => 'external',
    'break' => 'external',

    // special presets, Windows Media based
    'bofunk' => 'wmp',
    'myspacevideocode' => 'wmp',
    'myspace' => 'wmp',

    // special presets, QuickTime based
    'revver-mov' => 'qt',

    // special presets, DivX webplayer based
    'stage6' => 'divx',
);
